041c7c2f90d4d3d508e18846ec0d7a406ad66eec
[arvados.git] / build / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 COLUMNS=80
6 . `dirname "$(readlink -f "$0")"`/run-library.sh
7
8 read -rd "\000" helpmessage <<EOF
9 $(basename $0): Install and test Arvados components.
10
11 Exit non-zero if any tests fail.
12
13 Syntax:
14         $(basename $0) WORKSPACE=/path/to/arvados [options]
15
16 Options:
17
18 --skip FOO     Do not test the FOO component.
19 --only FOO     Do not test anything except the FOO component.
20 --temp DIR     Install components and dependencies under DIR instead of
21                making a new temporary directory. Implies --leave-temp.
22 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
23                Instead, show the path to give as --temp to reuse them in
24                subsequent invocations.
25 --skip-install Do not run any install steps. Just run tests.
26                You should provide GOPATH, GEMHOME, and VENVDIR options
27                from a previous invocation if you use this option.
28 --only-install Run specific install step
29 WORKSPACE=path Arvados source tree to test.
30 CONFIGSRC=path Dir with api server config files to copy into source tree.
31                (If none given, leave config files alone in source tree.)
32 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
33                Restrict apiserver tests to the given file
34 sdk/python_test="--test-suite test.test_keep_locator"
35                Restrict Python SDK tests to the given class
36 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
37                Restrict Workbench tests to the given file
38 services/arv-git-httpd_test="-check.vv"
39                Show all log messages, even when tests pass (also works
40                with services/keepstore_test etc.)
41 ARVADOS_DEBUG=1
42                Print more debug messages
43 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
44                *_test, and other examples shown above.
45
46 Assuming --skip-install is not given, all components are installed
47 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
48 test suites depend on other components being installed, and installing
49 everything tends to be quicker than debugging dependencies.
50
51 As a special concession to the current CI server config, CONFIGSRC
52 defaults to $HOME/arvados-api-server if that directory exists.
53
54 More information and background:
55
56 https://arvados.org/projects/arvados/wiki/Running_tests
57
58 Available tests:
59
60 apps/workbench
61 apps/workbench_benchmark
62 apps/workbench_profile
63 doc
64 services/api
65 services/arv-git-httpd
66 services/crunchstat
67 services/dockercleaner
68 services/fuse
69 services/keep-web
70 services/keepproxy
71 services/keepstore
72 services/login-sync
73 services/nodemanager
74 services/crunch-run
75 services/crunch-dispatch-local
76 services/crunch-dispatch-slurm
77 sdk/cli
78 sdk/pam
79 sdk/python
80 sdk/ruby
81 sdk/go/arvadosclient
82 sdk/go/keepclient
83 sdk/go/manifest
84 sdk/go/blockdigest
85 sdk/go/streamer
86 sdk/go/crunchrunner
87 sdk/cwl
88 tools/crunchstat-summary
89 tools/keep-rsync
90
91 EOF
92
93 # First make sure to remove any ARVADOS_ variables from the calling
94 # environment that could interfere with the tests.
95 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
96
97 # Reset other variables that could affect our [tests'] behavior by
98 # accident.
99 GITDIR=
100 GOPATH=
101 VENVDIR=
102 VENV3DIR=
103 PYTHONPATH=
104 GEMHOME=
105 PERLINSTALLBASE=
106
107 skip_install=
108 temp=
109 temp_preserve=
110
111 clear_temp() {
112     if [[ -z "$temp" ]]; then
113         # we didn't even get as far as making a temp dir
114         :
115     elif [[ -z "$temp_preserve" ]]; then
116         rm -rf "$temp"
117     else
118         echo "Leaving behind temp dirs in $temp"
119     fi
120 }
121
122 fatal() {
123     clear_temp
124     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
125     exit 1
126 }
127
128 exit_cleanly() {
129     trap - INT
130     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
131     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
132     stop_services
133     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
134     report_outcomes
135     clear_temp
136     exit ${#failures}
137 }
138
139 sanity_checks() {
140     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
141         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
142     echo Checking dependencies:
143     echo -n 'virtualenv: '
144     virtualenv --version \
145         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
146     echo -n 'go: '
147     go version \
148         || fatal "No go binary. See http://golang.org/doc/install"
149     echo -n 'gcc: '
150     gcc --version | egrep ^gcc \
151         || fatal "No gcc. Try: apt-get install build-essential"
152     echo -n 'fuse.h: '
153     find /usr/include -wholename '*fuse/fuse.h' \
154         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
155     echo -n 'pyconfig.h: '
156     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
157         || fatal "No pyconfig.h. Try: apt-get install python-dev"
158     echo -n 'nginx: '
159     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
160         || fatal "No nginx. Try: apt-get install nginx"
161     echo -n 'perl: '
162     perl -v | grep version \
163         || fatal "No perl. Try: apt-get install perl"
164     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
165         echo -n "perl $mod: "
166         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
167             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
168     done
169     echo -n 'gitolite: '
170     which gitolite \
171         || fatal "No gitolite. Try: apt-get install gitolite3"
172 }
173
174 rotate_logfile() {
175   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
176   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
177   if [[ -f "$1/$2" ]]; then
178     THEDATE=`date +%Y%m%d%H%M%S`
179     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
180     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
181   fi
182 }
183
184 declare -a failures
185 declare -A skip
186 declare -A testargs
187 skip[apps/workbench_profile]=1
188
189 while [[ -n "$1" ]]
190 do
191     arg="$1"; shift
192     case "$arg" in
193         --help)
194             echo >&2 "$helpmessage"
195             echo >&2
196             exit 1
197             ;;
198         --skip)
199             skipwhat="$1"; shift
200             skip[$skipwhat]=1
201             ;;
202         --only)
203             only="$1"; skip[$1]=""; shift
204             ;;
205         --skip-install)
206             skip_install=1
207             ;;
208         --only-install)
209             skip_install=1
210             only_install="$1"; shift
211             ;;
212         --temp)
213             temp="$1"; shift
214             temp_preserve=1
215             ;;
216         --leave-temp)
217             temp_preserve=1
218             ;;
219         --retry)
220             retry=1
221             ;;
222         *_test=*)
223             suite="${arg%%_test=*}"
224             args="${arg#*=}"
225             testargs["$suite"]="$args"
226             ;;
227         *=*)
228             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
229             ;;
230         *)
231             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
232             exit 1
233             ;;
234     esac
235 done
236
237 start_api() {
238     echo 'Starting API server...'
239     cd "$WORKSPACE" \
240         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
241         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
242         && export ARVADOS_TEST_API_INSTALLED="$$" \
243         && (env | egrep ^ARVADOS)
244 }
245
246 start_nginx_proxy_services() {
247     echo 'Starting keepproxy, keep-web, arv-git-httpd, and nginx ssl proxy...'
248     cd "$WORKSPACE" \
249         && python sdk/python/tests/run_test_server.py start_keep_proxy \
250         && python sdk/python/tests/run_test_server.py start_keep-web \
251         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
252         && python sdk/python/tests/run_test_server.py start_nginx \
253         && export ARVADOS_TEST_PROXY_SERVICES=1
254 }
255
256 stop_services() {
257     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
258         unset ARVADOS_TEST_PROXY_SERVICES
259         cd "$WORKSPACE" \
260             && python sdk/python/tests/run_test_server.py stop_nginx \
261             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
262             && python sdk/python/tests/run_test_server.py stop_keep-web \
263             && python sdk/python/tests/run_test_server.py stop_keep_proxy
264     fi
265     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
266         unset ARVADOS_TEST_API_HOST
267         cd "$WORKSPACE" \
268             && python sdk/python/tests/run_test_server.py stop
269     fi
270 }
271
272 interrupt() {
273     failures+=("($(basename $0) interrupted)")
274     exit_cleanly
275 }
276 trap interrupt INT
277
278 sanity_checks
279
280 echo "WORKSPACE=$WORKSPACE"
281
282 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
283     # Jenkins expects us to use this by default.
284     CONFIGSRC="$HOME/arvados-api-server"
285 fi
286
287 # Clean up .pyc files that may exist in the workspace
288 cd "$WORKSPACE"
289 find -name '*.pyc' -delete
290
291 if [[ -z "$temp" ]]; then
292     temp="$(mktemp -d)"
293 fi
294
295 # Set up temporary install dirs (unless existing dirs were supplied)
296 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
297 do
298     if [[ -z "${!tmpdir}" ]]; then
299         eval "$tmpdir"="$temp/$tmpdir"
300     fi
301     if ! [[ -d "${!tmpdir}" ]]; then
302         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
303     fi
304 done
305
306 setup_ruby_environment() {
307     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
308       source "$HOME/.rvm/scripts/rvm"
309       using_rvm=true
310     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
311       source "/usr/local/rvm/scripts/rvm"
312       using_rvm=true
313     else
314       using_rvm=false
315     fi
316
317     if [[ "$using_rvm" == true ]]; then
318         # If rvm is in use, we can't just put separate "dependencies"
319         # and "gems-under-test" paths to GEM_PATH: passenger resets
320         # the environment to the "current gemset", which would lose
321         # our GEM_PATH and prevent our test suites from running ruby
322         # programs (for example, the Workbench test suite could not
323         # boot an API server or run arv). Instead, we have to make an
324         # rvm gemset and use it for everything.
325
326         [[ `type rvm | head -n1` == "rvm is a function" ]] \
327             || fatal 'rvm check'
328
329         # Put rvm's favorite path back in first place (overriding
330         # virtualenv, which just put itself there). Ignore rvm's
331         # complaint about not being in first place already.
332         rvm use @default 2>/dev/null
333
334         # Create (if needed) and switch to an @arvados-tests
335         # gemset. (Leave the choice of ruby to the caller.)
336         rvm use @arvados-tests --create \
337             || fatal 'rvm gemset setup'
338
339         rvm env
340     else
341         # When our "bundle install"s need to install new gems to
342         # satisfy dependencies, we want them to go where "gem install
343         # --user-install" would put them. (However, if the caller has
344         # already set GEM_HOME, we assume that's where dependencies
345         # should be installed, and we should leave it alone.)
346
347         if [ -z "$GEM_HOME" ]; then
348             user_gempath="$(gem env gempath)"
349             export GEM_HOME="${user_gempath%%:*}"
350         fi
351         PATH="$(gem env gemdir)/bin:$PATH"
352
353         # When we build and install our own gems, we install them in our
354         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
355         # PATH so integration tests prefer them over other versions that
356         # happen to be installed in $user_gempath, system dirs, etc.
357
358         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
359         PATH="$tmpdir_gem_home/bin:$PATH"
360         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
361
362         echo "Will install dependencies to $(gem env gemdir)"
363         echo "Will install arvados gems to $tmpdir_gem_home"
364         echo "Gem search path is GEM_PATH=$GEM_PATH"
365     fi
366 }
367
368 with_test_gemset() {
369     if [[ "$using_rvm" == true ]]; then
370         "$@"
371     else
372         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
373     fi
374 }
375
376 gem_uninstall_if_exists() {
377     if gem list "$1\$" | egrep '^\w'; then
378         gem uninstall --force --all --executables "$1"
379     fi
380 }
381
382 setup_virtualenv() {
383     local venvdest="$1"; shift
384     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
385         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
386     fi
387     "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
388     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
389     "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
390 }
391
392 export PERLINSTALLBASE
393 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
394
395 export GOPATH
396 mkdir -p "$GOPATH/src/git.curoverse.com"
397 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
398     || fatal "symlink failed"
399
400 setup_virtualenv "$VENVDIR" --python python2.7
401 . "$VENVDIR/bin/activate"
402
403 # Needed for run_test_server.py which is used by certain (non-Python) tests.
404 pip freeze 2>/dev/null | egrep ^PyYAML= \
405     || pip install PyYAML >/dev/null \
406     || fatal "pip install PyYAML failed"
407
408 # Preinstall forked version of libcloud, because nodemanager "pip install"
409 # won't pick it up by default.
410 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
411     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
412     || fatal "pip install apache-libcloud failed"
413
414 # This will help people who reuse --temp dirs when we upgrade to llfuse 0.42
415 if egrep -q 'llfuse.*>= *0\.42' "$WORKSPACE/services/fuse/setup.py"; then
416     # Uninstall old llfuse, because services/fuse "pip install" won't
417     # upgrade it by default.
418     if pip freeze | egrep '^llfuse==0\.41\.'; then
419         yes | pip uninstall 'llfuse<0.42'
420     fi
421 fi
422
423 # Deactivate Python 2 virtualenv
424 deactivate
425
426 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
427 # Otherwise, skip dependent tests.
428 PYTHON3=$(which python3)
429 if [ "0" = "$?" ]; then
430     setup_virtualenv "$VENV3DIR" --python python3
431 else
432     PYTHON3=
433     skip[services/dockercleaner]=1
434     cat >&2 <<EOF
435
436 Warning: python3 could not be found
437 services/dockercleaner install and tests will be skipped
438
439 EOF
440 fi
441
442 # Reactivate Python 2 virtualenv
443 . "$VENVDIR/bin/activate"
444
445 # Note: this must be the last time we change PATH, otherwise rvm will
446 # whine a lot.
447 setup_ruby_environment
448
449 echo "PATH is $PATH"
450
451 if ! which bundler >/dev/null
452 then
453     gem install --user-install bundler || fatal 'Could not install bundler'
454 fi
455
456 retry() {
457     while ! ${@} && [[ "$retry" == 1 ]]
458     do
459         read -p 'Try again? [Y/n] ' x
460         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
461         then
462             break
463         fi
464     done
465 }
466
467 do_test() {
468     retry do_test_once ${@}
469 }
470
471 do_test_once() {
472     unset result
473     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
474     then
475         title "Running $1 tests"
476         timer_reset
477         if [[ "$2" == "go" ]]
478         then
479             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
480             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
481             # We do "go get -t" here to catch compilation errors
482             # before trying "go test". Otherwise, coverage-reporting
483             # mode makes Go show the wrong line numbers when reporting
484             # compilation errors.
485             if [[ -n "${testargs[$1]}" ]]
486             then
487                 # "go test -check.vv giturl" doesn't work, but this
488                 # does:
489                 cd "$WORKSPACE/$1" && \
490                     go get -t "git.curoverse.com/arvados.git/$1" && \
491                     go test ${coverflags[@]} ${testargs[$1]}
492             else
493                 # The above form gets verbose even when testargs is
494                 # empty, so use this form in such cases:
495                 go get -t "git.curoverse.com/arvados.git/$1" && \
496                     go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
497             fi
498             result="$?"
499             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
500             rm "$WORKSPACE/tmp/.$covername.tmp"
501         elif [[ "$2" == "pip" ]]
502         then
503             # $3 can name a path directory for us to use, including trailing
504             # slash; e.g., the bin/ subdirectory of a virtualenv.
505             cd "$WORKSPACE/$1" \
506                 && "${3}python" setup.py test ${testargs[$1]}
507         elif [[ "$2" != "" ]]
508         then
509             "test_$2"
510         else
511             "test_$1"
512         fi
513         result=${result:-$?}
514         checkexit $result "$1 tests"
515         title "End of $1 tests (`timer`)"
516         return $result
517     else
518         title "Skipping $1 tests"
519     fi
520 }
521
522 do_install() {
523     retry do_install_once ${@}
524 }
525
526 do_install_once() {
527     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
528     then
529         title "Running $1 install"
530         timer_reset
531         if [[ "$2" == "go" ]]
532         then
533             go get -t "git.curoverse.com/arvados.git/$1"
534         elif [[ "$2" == "pip" ]]
535         then
536             # $3 can name a path directory for us to use, including trailing
537             # slash; e.g., the bin/ subdirectory of a virtualenv.
538
539             # Need to change to a different directory after creating
540             # the source dist package to avoid a pip bug.
541             # see https://arvados.org/issues/5766 for details.
542
543             # Also need to install twice, because if it believes the package is
544             # already installed, pip it won't install it.  So the first "pip
545             # install" ensures that the dependencies are met, the second "pip
546             # install" ensures that we've actually installed the local package
547             # we just built.
548             cd "$WORKSPACE/$1" \
549                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
550                 && cd "$WORKSPACE" \
551                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
552                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
553         elif [[ "$2" != "" ]]
554         then
555             "install_$2"
556         else
557             "install_$1"
558         fi
559         result=$?
560         checkexit $result "$1 install"
561         title "End of $1 install (`timer`)"
562         return $result
563     else
564         title "Skipping $1 install"
565     fi
566 }
567
568 bundle_install_trylocal() {
569     (
570         set -e
571         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
572         if ! bundle install --local --no-deployment; then
573             echo "(Running bundle install again, without --local.)"
574             bundle install --no-deployment
575         fi
576         bundle package --all
577     )
578 }
579
580 install_doc() {
581     cd "$WORKSPACE/doc" \
582         && bundle_install_trylocal \
583         && rm -rf .site
584 }
585 do_install doc
586
587 install_gem() {
588     gemname=$1
589     srcpath=$2
590     with_test_gemset gem_uninstall_if_exists "$gemname" \
591         && cd "$WORKSPACE/$srcpath" \
592         && bundle_install_trylocal \
593         && gem build "$gemname.gemspec" \
594         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
595 }
596
597 install_ruby_sdk() {
598     install_gem arvados sdk/ruby
599 }
600 do_install sdk/ruby ruby_sdk
601
602 install_perl_sdk() {
603     cd "$WORKSPACE/sdk/perl" \
604         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
605         && make install INSTALLDIRS=perl
606 }
607 do_install sdk/perl perl_sdk
608
609 install_cli() {
610     install_gem arvados-cli sdk/cli
611 }
612 do_install sdk/cli cli
613
614 install_login-sync() {
615     install_gem arvados-login-sync services/login-sync
616 }
617 do_install services/login-sync login-sync
618
619 # Install the Python SDK early. Various other test suites (like
620 # keepproxy) bring up run_test_server.py, which imports the arvados
621 # module. We can't actually *test* the Python SDK yet though, because
622 # its own test suite brings up some of those other programs (like
623 # keepproxy).
624 declare -a pythonstuff
625 pythonstuff=(
626     sdk/pam
627     sdk/python
628     sdk/cwl
629     services/fuse
630     services/nodemanager
631     tools/crunchstat-summary
632     )
633 for p in "${pythonstuff[@]}"
634 do
635     do_install "$p" pip
636 done
637 if [ -n "$PYTHON3" ]; then
638     do_install services/dockercleaner pip "$VENV3DIR/bin/"
639 fi
640
641 install_apiserver() {
642     cd "$WORKSPACE/services/api" \
643         && RAILS_ENV=test bundle_install_trylocal
644
645     rm -f config/environments/test.rb
646     cp config/environments/test.rb.example config/environments/test.rb
647
648     if [ -n "$CONFIGSRC" ]
649     then
650         for f in database.yml application.yml
651         do
652             cp "$CONFIGSRC/$f" config/ || fatal "$f"
653         done
654     fi
655
656     # Fill in a random secret_token and blob_signing_key for testing
657     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
658     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
659
660     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
661     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
662
663     # Set up empty git repo (for git tests)
664     GITDIR=$(mktemp -d)
665     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
666
667     rm -rf $GITDIR
668     mkdir -p $GITDIR/test
669     cd $GITDIR/test \
670         && git init \
671         && git config user.email "jenkins@ci.curoverse.com" \
672         && git config user.name "Jenkins, CI" \
673         && touch tmp \
674         && git add tmp \
675         && git commit -m 'initial commit'
676
677     # Clear out any lingering postgresql connections to the test
678     # database, so that we can drop it. This assumes the current user
679     # is a postgresql superuser.
680     cd "$WORKSPACE/services/api" \
681         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
682         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
683
684     cd "$WORKSPACE/services/api" \
685         && RAILS_ENV=test bundle exec rake db:drop \
686         && RAILS_ENV=test bundle exec rake db:setup \
687         && RAILS_ENV=test bundle exec rake db:fixtures:load
688 }
689 do_install services/api apiserver
690
691 declare -a gostuff
692 gostuff=(
693     sdk/go/arvadosclient
694     sdk/go/blockdigest
695     sdk/go/manifest
696     sdk/go/streamer
697     sdk/go/crunchrunner
698     services/arv-git-httpd
699     services/crunchstat
700     services/keep-web
701     services/keepstore
702     sdk/go/keepclient
703     services/keepproxy
704     services/datamanager/summary
705     services/datamanager/collection
706     services/datamanager/keep
707     services/datamanager
708     services/crunch-dispatch-local
709     services/crunch-dispatch-slurm
710     services/crunch-run
711     tools/keep-rsync
712     )
713 for g in "${gostuff[@]}"
714 do
715     do_install "$g" go
716 done
717
718 install_workbench() {
719     cd "$WORKSPACE/apps/workbench" \
720         && mkdir -p tmp/cache \
721         && RAILS_ENV=test bundle_install_trylocal
722 }
723 do_install apps/workbench workbench
724
725 test_doclinkchecker() {
726     (
727         set -e
728         cd "$WORKSPACE/doc"
729         ARVADOS_API_HOST=qr1hi.arvadosapi.com
730         # Make sure python-epydoc is installed or the next line won't
731         # do much good!
732         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
733     )
734 }
735 do_test doc doclinkchecker
736
737 stop_services
738
739 test_apiserver() {
740     rm -f "$WORKSPACE/services/api/git-commit.version"
741     cd "$WORKSPACE/services/api" \
742         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
743 }
744 do_test services/api apiserver
745
746 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
747 # because we don't need to start up the api server for subsequent tests.
748 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
749   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
750   exit_cleanly
751 fi
752
753 start_api
754
755 test_ruby_sdk() {
756     cd "$WORKSPACE/sdk/ruby" \
757         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
758 }
759 do_test sdk/ruby ruby_sdk
760
761 test_cli() {
762     cd "$WORKSPACE/sdk/cli" \
763         && mkdir -p /tmp/keep \
764         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
765 }
766 do_test sdk/cli cli
767
768 test_login-sync() {
769     cd "$WORKSPACE/services/login-sync" \
770         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
771 }
772 do_test services/login-sync login-sync
773
774 for p in "${pythonstuff[@]}"
775 do
776     do_test "$p" pip
777 done
778 do_test services/dockercleaner pip "$VENV3DIR/bin/"
779
780 for g in "${gostuff[@]}"
781 do
782     do_test "$g" go
783 done
784
785 test_workbench() {
786     start_nginx_proxy_services \
787         && cd "$WORKSPACE/apps/workbench" \
788         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
789 }
790 do_test apps/workbench workbench
791
792 test_workbench_benchmark() {
793     start_nginx_proxy_services \
794         && cd "$WORKSPACE/apps/workbench" \
795         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
796 }
797 do_test apps/workbench_benchmark workbench_benchmark
798
799 test_workbench_profile() {
800     start_nginx_proxy_services \
801         && cd "$WORKSPACE/apps/workbench" \
802         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
803 }
804 do_test apps/workbench_profile workbench_profile
805
806 exit_cleanly